<!-- eslint-disable vue/no-template-shadow -->
<script setup lang="ts">
    import { computed, ref, watch } from 'vue'
    import { User } from '@/api/user/User'
    import { useUserValidation } from '@/shared/administration/composables/users/useUserValidation'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { ServiceOffer } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import { useConfigurationStore } from '../../stores/ConfigurationStore'
    import { isUndefined } from '@/shared/helpers/types'
    import { useServiceOffers } from '@/serviceOffer/components/composables/serviceOffer/serviceOffers'
    import SRoleList from '@/serviceOffer/components/administration/SRoleList.vue'

    interface Props {
        modelValue: User
        configurationStore: ReturnType<typeof useConfigurationStore>
        serviceOfferStore: ReturnType<typeof useServiceOffers>
        isProcessing: boolean
    }

    const props = defineProps<Props>()

    const openedRolesCategories = ref<ServiceOffer['id'][]>([])

    const emit = defineEmits<{
        'update:modelValue': [value: User]
    }>()

    const user = computed({
        get() {
            return props.modelValue
        },
        set(user) {
            emit('update:modelValue', user)
        },
    })

    watch([user, props.serviceOfferStore.serviceOffers], () => {
        props.serviceOfferStore.serviceOffers.value.forEach((serviceOffer) => {
            if (isUndefined(user.value)) {
                return
            }
            if (
                user.value.getNumberOfMatchingRoles(
                    serviceOffer.availableRoles
                ) > 0
            ) {
                openedRolesCategories.value.push(serviceOffer.id)
            }
        })
    })

    const addOrRemoveRoleFromList = (role: string) => {
        const index = user.value.roles.indexOf(role)
        if (index !== undefined && index !== -1) {
            user.value.roles.splice(index, 1)
        } else {
            user.value.roles.push(role)
        }
    }
    const serviceOfferTemplates = computed(() => {
        return props.serviceOfferStore.serviceOffers.value.reduce(
            (templates: ServiceOffer['template'][], serviceOffer) => {
                if (templates.includes(serviceOffer.template)) {
                    return templates
                }
                return [...templates, serviceOffer.template]
            },
            []
        )
    })
    const formIsValid = ref<boolean>(false)

    const { rules } = useUserValidation()
</script>
<template>
    <v-form ref="form" v-model="formIsValid" class="mx-auto" @submit.prevent="">
        <v-row>
            <v-col cols="12">
                <v-text-field
                    v-model="user.email"
                    label="Email"
                    :rules="[rules.hasEmail, rules.hasValidEmail]"
                    data-cy="email"
                ></v-text-field>
            </v-col>
            <v-col cols="12">
                <h3>Rôles Assignés</h3>
                <v-chip-group>
                    <v-chip
                        v-for="role in user.roles"
                        :key="role"
                        :closable="true"
                        @click:close="addOrRemoveRoleFromList(role)"
                    >
                        {{
                            serviceOfferStore.allAvailableRolesMap.value.get(
                                role
                            )?.serviceOfferTitle
                        }}
                        :
                        {{
                            serviceOfferStore.allAvailableRolesMap.value.get(
                                role
                            )?.libelle
                        }}
                    </v-chip>
                </v-chip-group>
            </v-col>
            <v-col cols="12">
                <h3>Rôles Globaux</h3>
                <s-role-list
                    v-for="globalRole in configurationStore.globalRoles"
                    :key="globalRole.value"
                    :role="globalRole"
                    :selected-roles="user.roles"
                    @toggle-role="addOrRemoveRoleFromList(globalRole.value)"
                />
            </v-col>
            <v-col cols="12">
                <h3>Rôles des offres de service</h3>
                <v-list
                    v-model:opened="openedRolesCategories"
                    open-strategy="multiple"
                >
                    <v-list-item
                        v-for="serviceOfferTemplate in serviceOfferTemplates"
                        :key="serviceOfferTemplate"
                        class="px-0"
                    >
                        <v-list-item-title>{{
                            configurationStore.templateNames[
                                serviceOfferTemplate
                            ]
                        }}</v-list-item-title>
                        <v-divider />

                        <v-list-group
                            v-for="serviceOffer in serviceOfferStore.serviceOffers.value.filter(
                                (serviceOffer) =>
                                    serviceOffer.template ===
                                    serviceOfferTemplate
                            )"
                            :key="serviceOffer.id"
                            :value="serviceOffer.id"
                            :fluid="$vuetify.display.mdAndDown"
                        >
                            <template #activator="{ props: activatorProps }">
                                <v-list-item
                                    v-bind="activatorProps"
                                    data-cy="service-offer-roles-dropdown"
                                >
                                    <v-list-item-title class="my-3">
                                        {{ serviceOffer.title }}
                                        <v-badge
                                            v-if="
                                                user.getNumberOfMatchingRoles(
                                                    serviceOffer.availableRoles
                                                ) > 0
                                            "
                                            inline
                                            :content="
                                                user.getNumberOfMatchingRoles(
                                                    serviceOffer.availableRoles
                                                )
                                            "
                                        ></v-badge>
                                    </v-list-item-title>
                                </v-list-item>
                            </template>

                            <v-list-item
                                v-for="serviceOfferRole in serviceOffer.availableRoles"
                                :key="serviceOfferRole.value"
                                :title="serviceOfferRole.libelle"
                                :subtitle="
                                    $vuetify.display.smAndUp
                                        ? serviceOfferRole.description
                                        : undefined
                                "
                                :value="serviceOfferRole.value"
                                @click="
                                    addOrRemoveRoleFromList(
                                        serviceOfferRole.value
                                    )
                                "
                            >
                                <template #prepend>
                                    <v-list-item-action start>
                                        <v-checkbox-btn
                                            :model-value="
                                                user.roles.includes(
                                                    serviceOfferRole.value
                                                )
                                            "
                                            data-cy="service-offer-roles-choice"
                                        ></v-checkbox-btn>
                                    </v-list-item-action>
                                </template>
                                <template
                                    v-if="$vuetify.display.smAndDown"
                                    #append
                                >
                                    <v-tooltip
                                        :text="serviceOfferRole.description"
                                        open-on-click
                                    >
                                        <template
                                            #activator="{
                                                props: activatorProps,
                                            }"
                                        >
                                            <v-icon
                                                v-bind="activatorProps"
                                                icon="mdi-information-outline"
                                                color="info"
                                            />
                                        </template>
                                    </v-tooltip>
                                </template>
                            </v-list-item>
                        </v-list-group>
                    </v-list-item>
                </v-list>
            </v-col>
            <v-col cols="12">
                <div class="text-right">
                    <s-action-button
                        :loading="isProcessing"
                        :disabled="!formIsValid"
                        icon="mdi-check"
                        label="Enregistrer"
                        data-cy="save-user-button"
                        type="submit"
                    ></s-action-button>
                </div>
            </v-col>
        </v-row>
    </v-form>
</template>
